﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.WebUI.UltraWebGauge;
using Infragistics.UltraGauge.Resources;
using System.Drawing;
using System.IO;
namespace GaugePresets
{
    public partial class Gauge : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                
                UltraGauge lCodedGauge = GetGauge();
                Stream lStream = new MemoryStream();
                lCodedGauge.SavePreset(lStream, "gauge", "theGauge", Infragistics.WebUI.PresetType.All);
                lCodedGauge.SavePreset(Server.MapPath("~/GaugePreset.xml"), "gauge", "theGauge", Infragistics.WebUI.PresetType.All);

                UltraGauge lFromStreamGauge = new UltraGauge();
                lFromStreamGauge.LoadPreset(lStream, true);

                UltraGauge lFromSavedXMLGauge = new UltraGauge();
                lFromSavedXMLGauge.LoadPreset(Server.MapPath("~/GaugePreset.xml"), true);

                UltraGauge lFromModifiedXMLGauge = new UltraGauge();
                lFromModifiedXMLGauge.LoadPreset(Server.MapPath("~/ModifiedGaugePreset.xml"), true);

                Panel1.Controls.Add(lCodedGauge);
                Panel2.Controls.Add(lFromStreamGauge);
                Panel3.Controls.Add(lFromSavedXMLGauge);
                Panel4.Controls.Add(lFromModifiedXMLGauge);
            }



        }

        protected UltraGauge GetGauge()
        {
            UltraGauge mUltraGauge = new UltraGauge();

            RadialGauge mGauge = new RadialGauge();
            mUltraGauge.Gauges.Add(mGauge);
            new RadialGauge();
            mGauge.Key = "radial";
            //mGauge.Dial.BrushElement = new SolidFillBrushElement(System.Drawing.Color.SkyBlue);
            BrushElementGroup lGroup = new BrushElementGroup();
            MultiStopRadialGradientBrushElement lMultiStop = new MultiStopRadialGradientBrushElement();
            lMultiStop.CenterPointMeasure = Measure.Percent;
            lMultiStop.ColorStops.Add(new ColorStop());
            lMultiStop.ColorStops[0].Color = System.Drawing.Color.FromArgb(161, 161, 161);
            lMultiStop.ColorStops.Add(new ColorStop());
            lMultiStop.ColorStops[1].Color = System.Drawing.Color.FromArgb(96, 96, 96);
            lMultiStop.ColorStops.Add(new ColorStop());
            //lMultiStop.ColorStops[1].Stop = 0.47;
            lMultiStop.ColorStops[2].Color = System.Drawing.Color.FromArgb(89, 89, 89);
            lGroup.BrushElements.Add(lMultiStop);
            mGauge.Dial.BrushElement = lGroup; ;
            mGauge.Dial.StrokeElement.Color = System.Drawing.Color.Navy;
            mGauge.Scales.Add(new RadialGaugeScale());
            //mGauge.Scales[0].Axis = new NumericAxis(0.0, 10.0, 1.0);
            //mGauge.Scales[0].StartAngle = 110.0;
            //mGauge.Scales[0].EndAngle = 430.0;
            mGauge.Scales[0].Labels.BrushElement = new SolidFillBrushElement(System.Drawing.Color.Black);

            mUltraGauge.BackColor = System.Drawing.Color.FromArgb(-655366);

            int lAlto = mUltraGauge.BitMapSize.Height;
            mUltraGauge.BitMapSize = new Size(174, lAlto);
            mUltraGauge.Width = new System.Web.UI.WebControls.Unit(174, System.Web.UI.WebControls.UnitType.Pixel);

            int lAncho = mUltraGauge.BitMapSize.Width;
            mUltraGauge.BitMapSize = new Size(lAncho, 174);
            mUltraGauge.Height = 174;

            mGauge.Bounds = new System.Drawing.Rectangle((mUltraGauge.BitMapSize.Height - 145) / 2, (mUltraGauge.BitMapSize.Width - 145) / 2 + 12, 145, 145);

            mUltraGauge.BackColor = System.Drawing.Color.FromArgb(-655366);

            mGauge.Scales[0].Labels.BrushElement = new SolidFillBrushElement(System.Drawing.Color.FromArgb(0));

            mGauge.Scales[0].StartAngle = 110;
            mGauge.Scales[0].EndAngle = 430;
            mGauge.Scales[0].Axis = new NumericAxis();
            mGauge.Scales[0].Axis.SetStartValue(0.0);
            mGauge.Scales[0].Axis.SetEndValue(500000.0);

            Infragistics.UltraGauge.Resources.BoxAnnotation lBox = new BoxAnnotation();
            lBox.BrushElement = new SolidFillBrushElement(System.Drawing.Color.FromArgb(-16732416));
            lBox.Visible = true;
            mGauge.Annotations.Add(lBox);

            FontStyle lStyle = FontStyle.Regular;

            (mGauge.Annotations[0] as BoxAnnotation).Label.Font = new System.Drawing.Font("Tahoma", 8, lStyle);
            (mGauge.Annotations[0] as BoxAnnotation).Label.BrushElement = new SolidFillBrushElement(System.Drawing.Color.FromArgb(-1));

            mUltraGauge.ToolTip = "Margen Bruto -  ARGENTINA";

            (mGauge.Annotations[0] as BoxAnnotation).Label.FormatString = "Margen Bruto -  ARGENTINA";


            RadialGaugeNeedle ndl0 = mGauge.Scales[0].Markers.AddNeedle();
            ndl0.MidWidth = 3;
            ndl0.EndWidth = 1;
            ndl0.MidExtent = 0;
            ndl0.EndExtent = 65;
            ndl0.StartExtent = -20;
            ndl0.Precision = 1;
            ndl0.WidthMeasure = Measure.Percent;
            ndl0.Value = 17000000.0;
            ndl0.StartWidth = 5;

            ndl0.BrushElement = new SolidFillBrushElement(System.Drawing.Color.FromArgb(-15000));

            ndl0.StrokeElement.Color = System.Drawing.Color.FromArgb(-15000 + 100);
            ndl0.StrokeElement.Thickness = 0;
            ndl0.Anchor.RadiusMeasure = Measure.Percent;

            SimpleGradientBrushElement lSimBE0 = new SimpleGradientBrushElement();
            lSimBE0.EndColor = System.Drawing.Color.FromArgb(64, 64, 64);
            lSimBE0.StartColor = System.Drawing.Color.Gainsboro;
            lSimBE0.GradientStyle = Gradient.BackwardDiagonal;
            RadialGradientBrushElement lRadBE0 = new RadialGradientBrushElement();
            lRadBE0.CenterColor = System.Drawing.Color.Gray;
            lRadBE0.SurroundColor = System.Drawing.Color.WhiteSmoke;
            ndl0.Anchor.BrushElement = lSimBE0;
            ndl0.Anchor.StrokeElement.BrushElement = lRadBE0;
            //ndl.StrokeElement.Thickness = vLargo;
            ndl0.EndExtent = 65;

            RadialGaugeNeedle ndl = mGauge.Scales[0].Markers.AddNeedle();
            ndl.MidWidth = 3;
            ndl.EndWidth = 1;
            ndl.MidExtent = 0;
            ndl.EndExtent = 65;
            ndl.StartExtent = -20;
            ndl.Precision = 1;
            ndl.WidthMeasure = Measure.Percent;
            ndl.Value = 13404824.762606077;
            ndl.StartWidth = 5;

            ndl.BrushElement = new SolidFillBrushElement(System.Drawing.Color.FromArgb(0));

            ndl.StrokeElement.Color = System.Drawing.Color.FromArgb(0 + 100);
            ndl.StrokeElement.Thickness = 0;
            ndl.Anchor.RadiusMeasure = Measure.Percent;

            SimpleGradientBrushElement lSimBE = new SimpleGradientBrushElement();
            lSimBE.EndColor = System.Drawing.Color.FromArgb(64, 64, 64);
            lSimBE.StartColor = System.Drawing.Color.Gainsboro;
            lSimBE.GradientStyle = Gradient.BackwardDiagonal;
            RadialGradientBrushElement lRadBE = new RadialGradientBrushElement();
            lRadBE.CenterColor = System.Drawing.Color.Gray;
            lRadBE.SurroundColor = System.Drawing.Color.WhiteSmoke;
            ndl.Anchor.BrushElement = lSimBE;
            ndl.Anchor.StrokeElement.BrushElement = lRadBE;
            //ndl.StrokeElement.Thickness = vLargo;
            ndl.EndExtent = 65;

            mGauge.Scales[0].Axis.SetStartValue(9651473.8290763758);
            mGauge.Scales[0].Axis.SetEndValue(14745307.238866685);

            SetColorRango(mGauge, 9651473.8290763758, 10723859.810084861, -65536);
            SetColorRango(mGauge, 10723859.810084861, 12064342.286345469, -256);
            SetColorRango(mGauge, 12064342.286345469, 14745307.238866685, -16744448);

            double lMin = double.MaxValue;
            double lMax = double.MinValue;
            foreach (RadialGaugeRange lRange in mGauge.Scales[0].Ranges)
            {
                if (Convert.ToDouble(lRange.StartValue) < lMin)
                    lMin = Convert.ToDouble(lRange.StartValue);
                if (Convert.ToDouble(lRange.EndValue) > lMax)
                    lMax = Convert.ToDouble(lRange.EndValue);
            }
            mGauge.Scales[0].Axis.SetStartValue(lMin);
            mGauge.Scales[0].Axis.SetEndValue(lMax);
            mGauge.Scales[0].MinorTickmarks.EndExtent = 95;
            mGauge.Scales[0].MinorTickmarks.StartExtent = 100;
            mGauge.Scales[0].MinorTickmarks.Frequency = (lMax - lMin) / 100;
            mGauge.Scales[0].MinorTickmarks.BrushElement = new SolidFillBrushElement(System.Drawing.Color.Black);

            mGauge.Scales[0].Labels.Frequency = (lMax - lMin) / 10;
            mGauge.Scales[0].Labels.Orientation = RadialLabelOrientation.Horizontal;
            //mGauge.Scales[0].Labels.SpanMaximum = 20;
            mGauge.Scales[0].Labels.Extent = 65;
            mGauge.Scales[0].Labels.EqualFontScaling = true;
            mGauge.Scales[0].Labels.Font = new System.Drawing.Font("Tahoma", Convert.ToInt32(mGauge.Bounds.Height / 28));
            mGauge.Scales[0].Labels.BrushElement = new SolidFillBrushElement(System.Drawing.Color.White);

            mGauge.Scales[0].MajorTickmarks.EndExtent = 100;
            mGauge.Scales[0].MajorTickmarks.StartExtent = 85;
            mGauge.Scales[0].MajorTickmarks.Frequency = (lMax - lMin) / 10;
            mGauge.Scales[0].MajorTickmarks.BrushElement = new SolidFillBrushElement(System.Drawing.Color.Black);

            //mUltraGauge.Gauges.Add(mGauge);
            //mUltraGauge.SavePreset(System.Configuration.ConfigurationManager.AppSettings["Camino_Gauge"], "gauge", "elgauge", Infragistics.WebUI.PresetType.All);
            //mUltraGauge.SavePreset(vStream, "gauge", "elgauge", Infragistics.WebUI.PresetType.All);
            
            return mUltraGauge;
        }

        public void SetColorRango(RadialGauge mGauge, double vInicioRango, double vFinRango, int vColor)
        {
            // mUltraChart.Axis.Y.RangeType = AxisRangeType.Automatic;
            //RadialGaugeScale lScale = mGauge.Scales[0];
            bool lEncontre = false;
            foreach (RadialGaugeRange lRange in mGauge.Scales[0].Ranges)
                if (Convert.ToDouble(lRange.StartValue) == vInicioRango && Convert.ToDouble(lRange.EndValue) == vFinRango)
                {
                    Infragistics.UltraGauge.Resources.TextureBrushElement lTexture = new Infragistics.UltraGauge.Resources.TextureBrushElement();
                    lTexture.StartColor = System.Drawing.Color.FromArgb(vColor + 200);
                    lTexture.EndColor = System.Drawing.Color.FromArgb(vColor);
                    lRange.BrushElement = lTexture;
                    lEncontre = true;
                    break;
                }
            if (!lEncontre)
            {
                int lRange = mGauge.Scales[0].Ranges.Add(new RadialGaugeRange());
                mGauge.Scales[0].Ranges[lRange].StartValue = vInicioRango;
                mGauge.Scales[0].Ranges[lRange].EndValue = vFinRango;

                Infragistics.UltraGauge.Resources.SimpleGradientBrushElement lTexture = new Infragistics.UltraGauge.Resources.SimpleGradientBrushElement();
                lTexture.StartColor = System.Drawing.Color.FromArgb(vColor + 200);
                lTexture.EndColor = System.Drawing.Color.FromArgb(vColor);
                lTexture.GradientStyle = Gradient.BackwardDiagonal;
                mGauge.Scales[0].Ranges[lRange].BrushElement = lTexture;
            }
            //lScale.Ranges.Add(lRange);
        }

        protected void Button1_Click1(object sender, EventArgs e)
        {
            //UltraGauge1.SavePreset(Server.MapPath("~/WorkingPreset_2.xml"), "gauge", "elgauge", Infragistics.WebUI.PresetType.All);
            //UltraGauge1.LoadPreset(Server.MapPath("~/WorkingPreset_2.xml"), false);
        }
    }
}